unless Kernel.respond_to?(:require_relative)
  module Kernel
    def require_relative(path)
      require File.join(File.dirname(caller[0]), path.to_str)
    end
  end
end

require_relative '../../provider/winrm'
require 'json'

Puppet::Type.type(:host_network_adapter).provide(:default, :parent => Puppet::Provider::Winrm) do

  def exists?
    adapter_names.empty? ? true : false
  end

  def adapter_names
    # MAC address can have "-" as seperator but Get-NetAdatper needs it with ":"
    updated_macs = resource[:mac_addresses].gsub(':','-')
    get_adapter = "Get-NetAdapter | ForEach-Object { if (#{quote(updated_macs)} -match $_.macaddress ) {echo $_.Name }} | ConvertTo-Json"
    @adapter_names = node_vmm( get_adapter )
  end

  def create
    Puppet.debug("Adapter Info : #{@adapter_info}")
    JSON.parse(@adapter_names).each do |adapter|
      if resource[:state].to_s == "Enabled"
        Puppet.debug("Enabling adapter #{adapter}")
        command = "Enable-NetAdapter -Name #{quote(adapter)} -AsJob"
      else
        Puppet.debug("Disabling adapter #{adapter}")
        command = "Disable-NetAdapter -Name #{quote(adapter)} -AsJob"
      end
      node_vmm( command )
    end

  end

  def destroy
    true
  end

end
