unless Kernel.respond_to?(:require_relative)
  module Kernel
    def require_relative(path)
      require File.join(File.dirname(caller[0]), path.to_str)
    end
  end
end

require_relative '../../provider/winrm'

Puppet::Type.type(:sc_logical_network).provide(:default, :parent => Puppet::Provider::Winrm) do

  def exists?
    filter = '| Select Name'
    result = vmm(exist_cmd+filter)
    result and result.include?(resource[:name])
  end

  def create
    vmm(create_cmd)
  end

  def destroy
    command = "#{exist_cmd} | Remove-SCLogicalNetwork"
    vmm(command)
  end

  def exist_cmd
    ps_cmd( 'Get-SCLogicalNetwork',
      {
        :VMMServer => 'localhost',
        :Name => quote(resource[:name]),
      },
      :terminate => false,
    )
  end

  def create_cmd
    ps_cmd( 'New-SCLogicalNetwork',
      {
        :VMMServer => 'localhost',
        :Name => quote(resource[:name]),
        :LogicalNetworkDefinitionIsolation => resource[:logical_network_definition_isolation],
        :EnableNetworkVirtualization => resource[:enable_network_virtualization],
        :UseGRE => resource[:use_gre],
        :IsPVLAN => resource[:is_pvlan],
        :RunAsynchronouly => resource[:async],
      },
      :terminate => false,
    )
  end
end
