unless Kernel.respond_to?(:require_relative)
  module Kernel
    def require_relative(path)
      require File.join(File.dirname(caller[0]), path.to_str)
    end
  end
end

require_relative '../../provider/winrm'

Puppet::Type.type(:sc_run_as_account).provide(:default, :parent => Puppet::Provider::Winrm) do

  def exists?
    result = vmm(exist_cmd)
    result.include? resource[:name]
  end

  def create
    vmm(create_cmd)
  end

  def destroy
    command =  "#{exist_cmd} | Remove-SCRunAsAccount"
    vmm(command)
  end

  def exist_cmd
    ps_cmd( 'Get-SCRunAsAccount',
      { 
        :VMMServer => 'localhost',
        :Name => quote(resource[:name]),
      },
      :terminate => false,
    )
  end

  def create_cmd
    command = ps_cmd( 'New-SCRunAsAccount',
      {
        :Credential => '$credential',
        :VMMServer => 'localhost',
        :Name => quote(resource[:name]),
        :Description => quote(resource[:description]),
        :RunAsynchronously => resource[:async],
      }
    )
    command = credential + command
  end
end
