unless Kernel.respond_to?(:require_relative)
  module Kernel
    def require_relative(path)
      require File.join(File.dirname(caller[0]), path.to_str)
    end
  end
end

require_relative '../../provider/winrm'

Puppet::Type.type(:sc_vm_network).provide(:default, :parent => Puppet::Provider::Winrm) do

  def exists?
    filter = '| Select Name'
    result = vmm(exist_cmd + filter)
    result and result.include?(resource[:name])
  end

  def create
    vmm(create_cmd)
  end

  def destroy
    remove_cmd = "| Remove-SCVMNetwork -name #{quote(resource[:name])} -LogicalNetwork #{quote(resource[:logical_network])}"
    command = exist_cmd + remove_cmd
    vmm(command)
  end

  def create_cmd
    logical_network = "$logical_network = Get-SCLogicalNetwork -Name #{quote(resource[:logical_network])};"
    command = ps_cmd( 'New-SCVMNetwork',
      {
        :VMMServer => 'localhost',
        :Name => quote(resource[:name]),
        :Description => quote(resource[:description]),
        :LogicalNetwork  => '$logical_network',
      },
    )

    command = logical_network + command
  end

  def exist_cmd
    ps_cmd( 'Get-SCVMNetwork',
      {
        :VMMServer => 'localhost',
        :Name => quote(resource[:name]),
      },
      :terminate => false,
    )
  end
end
