unless Kernel.respond_to?(:require_relative)
  module Kernel
    def require_relative(path)
      require File.join(File.dirname(caller[0]), path.to_str)
    end
  end
end

require_relative '../../provider/winrm'

Puppet::Type.type(:scvm_host_group).provide(:default, :parent => Puppet::Provider::Winrm) do

  def exists?
    result = vmm("Get-SCVMHostGroup -VMMServer localhost | where {$_.path -eq \"#{resource[:path]}\"} | Select-Object Path")
    result and result.include?(resource[:path])
  end

  def create
    path = Pathname.new(resource[:path].gsub(/\\/, File::SEPARATOR))
    parent_path = path.parent.to_s.gsub(File::SEPARATOR, '\\')
    name = quote(path.basename.to_s)
    vmm("$ParentGroup = (Get-SCVMHostGroup -VMMServer localhost | where {$_.path -eq \"#{parent_path}\"}); New-SCVMHostGroup -Name #{name} -ParentHostGroup $ParentGroup")
  end

  def destroy
    path = Pathname.new(resource[:path].gsub(/\\/, File::SEPARATOR))
    name = quote(path.basename.to_s)
    if name.downcase == 'all hosts'
      Puppet.debug('Root host-group cannot be removed. Skipping operation')
      return true
    end
    vmm("$HostGroup = (Get-SCVMHostGroup -VMMServer localhost -Name #{name}| where {$_.path -eq \"#{resource[:path]}\"}); Remove-SCVMHostGroup -VMHostGroup $HostGroup")
  end

end
