Puppet::Type.newtype(:iscsi_target_portal) do
  ensurable

  # TODO: may need composite namevar.
  newparam(:initiator_instance_name, :namevar => true) do
    desc 'the iscsi intiator instance name.'
  end

  newparam(:description) do
    desc 'User description'
  end

  newparam(:authentication_type) do
    desc 'authentication for target login'
    newvalues(:None,:OneWayCHAP,:MutualCHAP)
    defaultto(:None)
  end

  newparam(:chap_username) do
    desc 'username for mutual chap'
  end

  newparam(:chap_secret) do
    desc 'CHAP secret for authentication'
  end

  newparam(:target_portal_address) do
    desc 'ipaddress or dns name of target portal'
  end

  newparam(:target_portal_port_number) do
    desc 'target portal port number'
    newvalues(/^\d+$/)
    defaultto(3260)
  end
end
