Puppet::Type.newtype(:sc_logical_network) do
  ensurable

  newparam(:name, :namevar => true) do
    desc 'SCVMM logical network'
  end

  # TODO: This should be a property
  newparam(:description) do
    desc 'Logical network description'
  end

  newparam(:logical_network_definition_isolation) do
    newvalues(:true, :false)

    munge do |value|
      case value
      when TrueClass, :true
        '$true'
      when FalseClass, :false
        '$false'
      end
    end
  end

  newparam(:enable_network_virtualization) do
    newvalues(:true, :false)

    munge do |value|
      case value
      when TrueClass, :true
        '$true'
      when FalseClass, :false
        '$false'
      end
    end
  end

  newparam(:use_gre) do
    newvalues(:true, :false)

    munge do |value|
      case value
      when TrueClass, :true
        '$true'
      when FalseClass, :false
        '$false'
      end
    end
  end

  newparam(:is_pvlan) do
    newvalues(:true, :false)

    munge do |value|
      case value
      when TrueClass, :true
        '$true'
      when FalseClass, :false
        '$false'
      end
    end
  end

  newparam(:async) do
    desc 'Process the request asynchronously (no longer confirm operation completed successfully).'
    newvalues(:true,:false)
    defaultto(:false)
  end
end
