Puppet::Type.newtype(:sc_virtual_machine) do
  ensurable

  newparam(:name, :namevar => true) do
    desc 'Virtual Machine name'
  end

  # TODO: This should be a property
  newparam(:description) do
    desc 'Virtual Machine description.'
  end

  newparam(:vm_configuration) do
  end

  newparam(:template) do
  end

  newparam(:vm_cluster) do
  end

  newparam(:vm_host) do
  end

  newparam(:block_dynamic_optimization) do
    newvalues(:true, :false)

    defaultto(false)

    munge do |value|
      case value
      when TrueClass, :true
        '$true'
      when FalseClass, :false
        '$false'
      end
    end
  end

  newparam(:path) do
    desc 'The hostgroup the VM resides in.'
    munge do |path|
      path.gsub('/','\\')
    end
  end

  newparam(:cloud) do
  end

  newparam(:cpu_count) do
    newvalues(/^\d+$/)
  end

  newparam(:memory_mb) do
    newvalues(/^\d+$/)
  end

  newparam(:start_action) do
    newvalues(:never_auto_turn_on_vm, :always_auto_turn_on_vm, :turn_on_vm_if_running_when_vs_stopped)
    defaultto(:never_auto_turn_on_vm)

    munge do |value|
      value.to_s.gsub('_','')
    end
  end

  newparam(:stop_action) do
    newvalues(:save_vm, :turn_off_vm, :shutdown_guest_os)
    defaultto(:save_vm)

    munge do |value|
      value.to_s.gsub('_','')
    end
  end

  newparam(:timezone) do
  end

  newparam(:hardware_profile) do
  end

  newparam(:domain) do
  end

  newparam(:domain_username) do
  end

  newparam(:domain_password) do
  end

  newparam(:product_key) do
  end

  newparam(:highly_available) do
    newvalues(:true, :false)

    munge do |value|
      case value
      when TrueClass, :true
        '$true'
      when FalseClass, :false
        '$false'
      end
    end
  end

  newparam(:async) do
    desc 'Process the request asynchronously (no longer confirm operation completed successfully).'
    newvalues(:true,:false)
    defaultto(:false)
  end

  autorequire(:scvm_host_group) do
    Pathname.new(self[:path].gsub(/\\/, File::SEPARATOR)).
      parent.to_s.gsub(File::SEPARATOR, '\\')
  end
end
