Puppet::Type.newtype(:scvm_host) do
  ensurable

  newparam(:name, :namevar => true) do
    desc 'hostname'
  end

  newparam(:path) do
    desc 'The fully qualified path of the host'
    munge do |path|
      path.gsub('/','\\')
    end
  end

  newparam(:username) do
    desc 'Domain username'
  end

  newparam(:password) do
    desc 'Domain password'
  end

  # TODO: This should be a property
  newparam(:management_account) do
    desc 'Host management account.'
  end

  newparam(:async) do
    desc 'Process the request asynchronously (no longer confirm operation completed successfully).'
    newvalues(:true,:false)
    defaultto(:false)
  end

  autorequire(:scvm_host_group) do
    self[:path]
  end

  autorequire(:sc_run_as_account) do
    self[:management_account]
  end
end
