# TODO: extract property code to generic module
# We need some of the nice wrappers to puppet type
#
vmware_module = Puppet::Module.find('vmware_lib', Puppet[:environment].to_s)
require File.join vmware_module.path, 'lib/puppet/property/vmware'

Puppet::Type.newtype(:scvm_host_adapter) do
  ensurable

  newparam(:name, :namevar => true) do
    desc 'clustername'
  end

  newparam(:path) do
    desc 'The fully qualified path of the cluster'
    munge do |path|
      path.gsub('/','\\')
    end
  end

  newproperty(:hosts, :parent => Puppet::Property::VMware_Array,
        :array_matching => :all, :sort => :true) do
    desc 'The hosts that participate in the cluster'
  end

  newparam(:username) do
    desc 'Domain username'
  end

  newparam(:password) do
    desc 'Domain password'
  end

  newparam(:fqdn) do
    desc 'Domain FQDN'
  end

  autorequire(:scvm_host_group) do
    self[:path]
  end
end
