require 'spec_helper'
require 'facter/initiator_ports'

describe 'initiator_ports fact' do
  before :each do
    Facter.fact(:osfamily).stubs(:value).returns :windows
  end

  after :each do
    Facter.clear
  end

  context 'iSCSI initiator' do
    it 'should return ports as comma seperated string' do
      Facter::Util::Resolution.expects(:exec).
        with('powershell "Get-InitiatorPort | Select-Object -Property InstanceName | Format-List"').
        returns(my_fixture_read('twoports'))

      Facter.fact(:initiator_ports).value.should == "EBDRV\\L4SC&PCI_168E14E4&SUBSYS_100614E4&REV_10\\5&33f88d71&0&30054400_0,EBDRV\\L4SC&PCI_168E14E4&SUBSYS_100614E4&REV_10\\5&213edccc&0&30054400_0"
    end

    it 'should ignore ROOT port' do
      Facter::Util::Resolution.expects(:exec).
        with('powershell "Get-InitiatorPort | Select-Object -Property InstanceName | Format-List"').
        returns(my_fixture_read('rootports'))

      Facter.fact(:initiator_ports).value.should == "EBDRV\\L4SC&PCI_168E14E4&SUBSYS_100614E4&REV_10\\5&33f88d71&0&30054400_0,EBDRV\\L4SC&PCI_168E14E4&SUBSYS_100614E4&REV_10\\5&213edccc&0&30054400_0"
    end

    it 'should accept empty ports' do
      Facter::Util::Resolution.expects(:exec).
        with('powershell "Get-InitiatorPort | Select-Object -Property InstanceName | Format-List"').
        returns('')

      Facter.fact(:initiator_ports).value.should be_nil
    end
  end
end
