require 'spec_helper'

describe "the scvm_host_group_expand function" do
  let(:scope) { PuppetlabsSpec::PuppetInternals.scope }

  it "should exist" do
    Puppet::Parser::Functions.function("scvm_host_group_expand").should == "function_scvm_host_group_expand"
  end

  it "should raise a ParseError if there is less than 1 arguments" do
    lambda { scope.function_scvm_host_group_expand([]) }.should( raise_error(Puppet::ParseError))
  end

  it "should return the size of a string" do
    result = scope.function_scvm_host_group_expand(["All Hosts\\a\\b"])
    result.should(eql(['All Hosts/a/b', 'All Hosts/a']))
  end
end
