import 'sample_data.pp'

transport { 'winrm':
  server   => $data['server'],
  username => $data['username'],
  password => $data['password'],
}

sc_logical_network { $logicalnetwork['name']:
  ensure                               => present,
  logical_network_definition_isolation => false,
  enable_network_virtualization        => true,
  use_gre                              => true,
  is_pvlan                             => false,
  transport                            => Transport['winrm'],
}

sc_logical_network_definition { $logicalnetworkdefinition['name']:
  ensure          => present,
  logical_network => $logicalnetwork['name'],
  host_groups     => [
    $hostcluster['path'],
    'All Hosts\aHV1230',
  ],
  subnet_vlans    => [
    {
      'vlan'   => 20,
      'subnet' => '',
    },
    {
      'vlan'   => 21,
      'subnet' => '',
    },
    {
      'vlan'   => 22,
      'subnet' => '',
    },
  ],
  inclusive       => false,
  transport       => Transport['winrm'],
}
