import 'sample_data.pp'

transport { 'winrm':
  server   => $data['server'],
  username => $data['username'],
  password => $data['password'],
}

sc_virtual_machine { 'demo':
  ensure          => present,
  path            => 'C:\\',
  vm_host         => $host['name'],
  template        => 'AmyTestTemplate',
  cpu_count       => 2,
  memory_mb       => 1024,
  start_action    => 'always_auto_turn_on_vm',
  transport       => Transport['winrm'],
}

sc_virtual_network_adapter { 'demo:1':
  ensure    => present,
  ipv4_address_type => static,
  mac_address_type => static,
  mac_address => '00:00:00:00:00:00',
  vlan_enabled => true,
  vlan_id => '21',
  transport => Transport['winrm'],
}
